var document = {

    body: {

        style: {}

    },

    documentElement: {
        style: {}
    },

    head: {
        prepend: function () {
        }
    },

    addEventListener: function () {
    },

    createDocumentFragment: function () {
        return {
            appendChild: function () {
                return {};
            }
        };
    },

    createElement: function () {
        return {
            getContext: function () {
                return undefined;
            },

            setAttribute: function () {

            },

            getElementsByTagName: function () {
                return [];
            },

            appendChild: function () {
                return {};
            }
        }
    }
};

function analyzeData(data) {

    data = JSON.parse(data);

    var result = window.Advisor.analyze(data);

    for (var i = 0; i < result.length; i++) {
        var type = result[i].type;

        result[i].categorys = [];

        if (type === "pie_chart") {
            result[i].categorys.push(result[i].channels.color);
        } else if (type === "line_chart" || type === "area_chart" || type === "column_chart") {
            result[i].categorys.push(result[i].channels.x);
            result[i].categorys.push(result[i].channels.color);
        } else if (type === "bar_chart") {
            result[i].categorys.push(result[i].channels.y);
            result[i].categorys.push(result[i].channels.color);
        } else if (type === 'stacked_bar_chart' || type === 'percent_stacked_bar_chart') {
            result[i].categorys.push(result[i].channels.y);
            result[i].categorys.push(result[i].channels.y2);
        } else if (type === 'stacked_column_chart' || type === 'percent_stacked_column_chart'
            || type === 'stacked_area_chart' || type === 'percent_stacked_area_chart'
            || type === 'radar_chart' || type === 'treemap' || type === 'mechanical_bubble_chart') {
            result[i].categorys.push(result[i].channels.x);
            result[i].categorys.push(result[i].channels.x2);
        } else if (type === 'wordcloud' || type === 'funnel_chart') {
            result[i].categorys.push(result[i].channels.series);
        } else if (type === 'scatter_plot' || type === 'bubble_chart') {
            result[i].categorys.push(result[i].channels.x);
            result[i].categorys.push(result[i].channels.y);
            result[i].categorys.push(result[i].channels.size);
        }
    }

    return JSON.stringify(result);
}