/**
 * Created by vito on 2017/12/19.
 * form 入口
 */
require(['jquery', 'fr.base', 'fr.widget', 'fr.chart', 'fr.plugin'], function ($) {

    var extra = "${jslink}${PageScript}";
    if (extra) {
        $('.fr-extra-script').html(extra);
    }
     window.initialWindowWidth = ${frWinWidth};
     window.initialWindowHeight = ${frWinHeight};

    //ie下低版本时修改浏览器渲染模式
    if ($.browser.msie && $.browser.version <= 8.0) {
        $("meta[http-equiv='X-UA-Compatible']").attr("content", "IE=5, IE=EmulateIE7, chrome=1");
    }
    $(function () {
        var $body = $('body');
        $('<form class="form-submit"></form>').attr('name', '${formlet_title}').appendTo($body);

        var items = [];
        var scrollHeight = 6;
        var expandHeight = 8;
        var contenConfig = ${config};
        var paraConfig = ${paraConfig};

        var contentContainer = $("<div class='content-container'>");
        var delayDisplay = paraConfig['delayDisplayContent'];

        contenConfig.renderEl = contentContainer;
        form = new FR.contentForm(contenConfig);
        FR.SessionMgr.register("${sessionID}", form);

        items.push({
            region: 'center',
            el: contentContainer
        });

        window.globalForm = form;
        var barHeight = paraConfig.width > document.body.offsetWidth ? scrollHeight : 0;
        FR.$defaultImport('/com/fr/web/core/js/paramtemplate.js', 'js');
        var paramstemplateHeight = 30;
        var north = {
            region: 'north',
            height: paramstemplateHeight,
            el: {
                type: 'border',
                widgetName: 'paramsTemplate',
                items: [
                    {
                        region: 'east',
                        width: 138,
                        el: {
                            type: 'horizontal',
                            alignment: 'right',
                            items: [{
                                el: {
                                    type: 'button',
                                    widgetName: 'saveBtn',
                                    text: FR.i18nText("Fine-Engine_Report_Designer_Save_As_Params_Template")
                                }, width: 128
                            }]
                        }
                    }, {
                        region: 'center',
                        el: {
                            type: 'horizontal',
                            widgetName: 'paramsTemplatePane',
                            width: paraConfig.width - 120,
                            minWidth: paraConfig.width - 120,
                            alignment: 'left',
                            items: []
                        }
                    }, {
                        region: 'west',
                        width: 30,
                        el: {
                            type: 'horizontal',
                            alignment: 'left',
                            items: [
                                {
                                    el: {
                                        type: 'iconbutton',
                                        widgetName: 'newParamsBtn',
                                        width: 30,
                                        baseClass: 'fs-new-params-template-blue'
                                    },
                                    width: 30
                                }
                            ]
                        }
                    }
                ]
            }
        };
        if (!paraConfig.useParamsTemplate || FR.isEmpty(getParamsTemplate(form.sessionID))) {
            paramstemplateHeight = 0;
            north = {};
        }
        if (!$.isEmptyObject(paraConfig)) {
            var paraContainer = $("<div class='para-container' style='overflow: auto;'>");
            var alignLayoutName = '__layout4align__';
            paraContainer.height(paraConfig.height + expandHeight + barHeight + paramstemplateHeight);
            var $expandEl = $("<div class='parameter-container-collapseimg-up' style='cursor: pointer'></div>");
            bindParaCollapse($expandEl);
            var $center = $('<div class="pmeter-container"></div>');
            var south = {
                region: 'south', height: expandHeight, el: {
                    type: 'horizontal',
                    items: [
                        {el: $expandEl, width: 120}
                    ]
                }
            };
            var center = {
                region: 'center',
                el: {
                    type: 'horizontal',
                    widgetName: alignLayoutName,
                    alignment: paraConfig.position,
                    items: [
                        {el: $center, width: paraConfig.width}
                    ]
                }
            };
            var itemlst = [north, south, center];
            var pCon = {
                renderEl: paraContainer,
                type: 'border',
                items: itemlst
            };
            //有个默认的背景
            var bg = FR.isEmptyObj(paraConfig.parambg) ? {background: '#f7f8fa'} : paraConfig.parambg;
            FR.setBackground(paraContainer, bg);
            paraConfig.renderEl = $center;
            window.globalForm.parameterEl = new FR.contentForm(paraConfig);
            items.push({
                region: 'north',
                el: pCon
            });
        }
            var width = FR.windowWidth || window.initialWindowWidth;
            var height = FR.windowHeight || window.initialWindowHeight;
            var borderLayout = new FR.BorderLayout({
                items: items,
                renderEl: $body,
                width: width,
                height: height
            });

        //给参数界面添加横向滚动条
        addScollBar(paraContainer, $center, paraConfig.height, scrollHeight);
        borderLayout.doLayout();
        $('[widgetname^=sortable]').removeAttr('style');
        initParameterTemplate(paraConfig, paraConfig.items, form.sessionID, borderLayout);

        $(window).resize(function () {
                  borderLayout.element.css({
                            width: '100%',
                            height: '100%'
                        });
            if (!form.scaleProcess(borderLayout, width, height)) {
                addScollBar(paraContainer, $center, paraConfig.height, scrollHeight);
                borderLayout.doLayout();
                $('[widgetname^=sortable]').removeAttr('style');
            }
            if (FR.Browser.isIE()) {
                setTimeout(function () {
                    width = FR.windowWidth;
                    height = FR.windowHeight;
                }, 0);
            } else {
                width = FR.windowWidth;
                height = FR.windowHeight;
            }
        });
        // 整个form都doLayout一下
        var browser = $.browser;
        //b:for chrome,find reason
        if (browser.safari && browser.webkit || browser.msie && browser.version < 7) {
            $(window).trigger("resize");
            $body.css('overflow', 'auto');
        }
        // FR.Layout 有this.element.css("overflow","hidden");
        //放大后再缩小, body和contentContainer大小一致, 却出现了滚动条, 很难看.
        contentContainer.css('overflow', 'auto');

        if (!delayDisplay) {
            form.parameterCommit();
        }

        function addScollBar(container, mover, top, height) {
            if (container) {
                container.hScrollPane({
                    mover: mover, //指定container对象下的哪个元素需要滚动位置 | 必传项;
                    showArrow: false, //指定是否显示左右箭头，默认不显示 | 可选项;
                    top: top, //滚动条所在的top位置
                    height: height,//滚动条的高度
                    //moverW:function(){return $(".press").width();}(), //传入水平滚动对象的长度值,不传入的话默认直接获取mover的宽度值 | 可选项;
                    //handleMinWidth:100,//指定handle的最小宽度,要固定handle的宽度请在css中设定handle的width属性（如 width:28px!important;），不传入则不设定最小宽度 | 可选项;
                    //dragable:true, //指定是否要支持拖动效果，默认可以拖动 | 可选项;
                    easing: false, //滚动是否需要滑动效果,默认有滑动效果 | 可选项;
                    // handleCssAlter:"draghandlealter", //指定拖动鼠标时滚动条的样式，不传入该参数则没有变化效果 | 可选项;
                    mousewheel: {bind: false, moveLength: 500} //mousewheel: bind->'true',绑定mousewheel事件; ->'false',不绑定mousewheel事件；moveLength是指定鼠标滚动一次移动的距离,默认值：{bind:true,moveLength:300} | 可选项;
                });
            }
        }

        function bindParaCollapse($element) {
            $element.click(function () {
                var resizeTime = new Date();
                var self = this;
                self.lastResizeTime = resizeTime;
                setTimeout(function () {
                    if (resizeTime === self.lastResizeTime) {
                        self.lastResizeTime = null;    // REPORT-4620，这里使用delete在IE8以下会有bug
                        paraContainer.animate({
                            height: (self.hasCollapsed ? "+=" : "-=") + (paraConfig.height + barHeight + paramstemplateHeight)
                        }, "fast", function () {
                            var height = paraContainer.height();
                            self.hasCollapsed = !self.hasCollapsed;
                            $expandEl.switchClass('parameter-container-collapseimg-down', 'parameter-container-collapseimg-up');
                            borderLayout.getWidgetByName(alignLayoutName).setVisible(!self.hasCollapsed);
                            if (borderLayout.getWidgetByName('paramsTemplatePane') !== undefined) {
                                borderLayout.getWidgetByName('paramsTemplatePane').setVisible(!self.hasCollapsed);
                            }
                            borderLayout.regionField.center.el = $('.content-container');
                            borderLayout.setRegionWH('north', height);
                            borderLayout.doLayout();
                            $('[widgetname^=sortable]').removeAttr('style');
                        });
                    }
                }, 222);
            });
        }

    });

    ${reportListScript};
});