window.Advisor = function(e) {
  var a = {};

  function t(n) {
    if (a[n]) return a[n].exports;
    var r = a[n] = { i: n, l: !1, exports: {} };
    return e[n].call(r.exports, r, r.exports, t), r.l = !0, r.exports;
  }

  return t.m = e, t.c = a, t.d = function(e, a, n) {
    t.o(e, a) || Object.defineProperty(e, a, { enumerable: !0, get: n });
  }, t.r = function(e) {
    'undefined' != typeof Symbol && Symbol.toStringTag && Object.defineProperty(e, Symbol.toStringTag, { value: 'Module' }), Object.defineProperty(e, '__esModule', { value: !0 });
  }, t.t = function(e, a) {
    if (1 & a && (e = t(e)), 8 & a) return e;
    if (4 & a && 'object' == typeof e && e && e.__esModule) return e;
    var n = Object.create(null);
    if (t.r(n), Object.defineProperty(n, 'default', {
      enumerable: !0,
      value: e,
    }), 2 & a && 'string' != typeof e) for (var r in e) t.d(n, r, function(a) {
      return e[a];
    }.bind(null, r));
    return n;
  }, t.n = function(e) {
    var a = e && e.__esModule ? function() {
      return e.default;
    } : function() {
      return e;
    };
    return t.d(a, 'a', a), a;
  }, t.o = function(e, a) {
    return Object.prototype.hasOwnProperty.call(e, a);
  }, t.p = '', t(t.s = 0);
}([function(e, a, t) {
  'use strict';
  t.r(a), t.d(a, 'analyze', (function() {
    return xe;
  }));
  var n = {
    'en-US': null, 'zh-CN': {
      concepts: {
        family: {
          LineCharts: '折线图类',
          ColumnCharts: '柱状图类',
          BarCharts: '条形图类',
          PieCharts: '饼图类',
          AreaCharts: '面积图类',
          ScatterCharts: '散点图类',
          FunnelCharts: '漏斗图类',
          HeatmapCharts: '热力图类',
          RadarCharts: '雷达图类',
          TreeGraph: '树形关系类',
          GeneralGraph: '关系图类',
          PointLayer: '点图层类',
          LineLayer: '线图层类',
          PolygonLayer: '面图层类',
          HeatmapLayer: '地图热力图类',
          Others: '其他类',
        },
        category: { Statistic: '统计图表', Diagram: '示意图', Graph: '关系图', Map: '地图' },
        purpose: {
          Comparison: '比较',
          Trend: '趋势',
          Distribution: '分布',
          Rank: '排名',
          Proportion: '占比',
          Composition: '组成',
          Relation: '关系',
          Hierarchy: '层级',
          Flow: '流向',
          Spatial: '空间',
        },
        coord: {
          NumberLine: '数轴',
          Cartesian2D: '二维直角坐标系',
          SymmetricCartesian: '对称直角坐标系',
          Cartesian3D: '三维直角坐标系',
          Polar: '极坐标系',
          NodeLink: '点线关系网络',
          Radar: '雷达型坐标系',
          Geo: '地理坐标系',
          Other: '其他',
        },
        shape: {
          Lines: '线形',
          Bars: '条形',
          Round: '圆形',
          Square: '方形',
          Area: '面形',
          Scatter: '散点形',
          Symmetric: '对称形',
          Network: '网络形',
          Map: '地图',
        },
        channel: {
          Position: '位置',
          Length: '长度',
          Color: '颜色',
          Area: '面积',
          Angle: '角度',
          ArcLength: '弧长',
          Direction: '方向',
          Size: '大小',
          Opacity: '透明度',
          Stroke: '线色',
          LineWidth: '线粗',
          Lightness: '亮度',
        },
        lom: { Continuous: '连续', Discrete: '离散', Interval: '数值', Nominal: '无序名词', Ordinal: '有序名词', Time: '时间' },
        recRate: { Recommended: '推荐', 'Use with Caution': '慎用', 'Not Recommended': '不推荐' },
      }, chartTypes: {
        line_chart: { name: '折线图', alias: ['折线图', '线图'], def: '使用折线的线段显示数据在一个具有顺序性的维度上的变化。' },
        step_line_chart: {
          name: '阶梯图',
          alias: ['阶梯线'],
          def: '折线根据分类字段分为多根在 x 方向（时间）的信息是完全一致、颜色及 y 方向（变量）信息不一致的折线，通常用作同一时间区间内多个变量发展趋势的对比。',
        },
        area_chart: { name: '面积图', alias: [], def: '使用带填充区域的线段显示数据在一个具有顺序性的维度上的变化。' },
        stacked_area_chart: {
          name: '堆叠面积图',
          alias: [],
          def: '使用带不同样式的填充区域的层叠线段来显示多组数据在同一个具有顺序性的维度上的变化，线段在同一维度值上的端点高度按照数值累加。',
        },
        percent_stacked_area_chart: {
          name: '百分比堆叠面积图',
          alias: ['%堆叠面积图', '100%堆叠面积图'],
          def: '一种特殊的堆叠面积图，线段在同一维度值上的端点高度代表值在其中的占比，占比总和为百分之百。',
        },
        interval_area_chart: { name: '', alias: [], def: 'TBD' },
        stream_chart: { name: '', alias: [], def: 'TBD' },
        column_chart: { name: '柱状图', alias: ['柱形图'], def: '使用柱形显示维度的数值。横轴显示分类维度，纵轴显示相应的值。' },
        grouped_column_chart: {
          name: '分组柱状图',
          alias: ['簇状柱状图'],
          def: '使用颜色不同的柱形并排组成小组来显示各维度的数值。横轴标示出分组，颜色标示出分类，纵轴显示相应的值。',
        },
        stacked_column_chart: {
          name: '堆叠柱状图',
          alias: [],
          def: '使用颜色不同的堆叠的柱形来显示各维度的数值。横轴标示出第一个分类维度，颜色标示出第二个分类维度，纵轴显示相应的值。',
        },
        percent_stacked_column_chart: {
          name: '百分比堆叠柱状图',
          alias: ['%堆叠柱状图', '100%堆叠柱状图'],
          def: '使用颜色不同的堆叠的柱形来显示各维度的数值。横轴标示出第一个分类维度，颜色标示出第二个分类维度，纵轴显示相应分类所占的百分比。',
        },
        interval_column_chart: { name: '', alias: [], def: 'TBD' },
        range_column_chart: { name: '区间柱状图', alias: [], def: '区间柱状图是一种特殊的柱状图，柱子不一定要从 0 开始，而是用柱子长度表示一个从起始值到终止值的区间。' },
        waterfall_chart: { name: '瀑布图', alias: ['桥图'], def: '瀑布图形似瀑布流水，采用绝对值与相对值结合的方式，适用于表达数个特定数值之间的数量变化关系。' },
        histogram: { name: '直方图', alias: [], def: '直方图是一种统计报告图，由一系列高度不等的纵向条纹或线段表示数据分布的情况。' },
        bar_chart: { name: '条形图', alias: ['条状图'], def: '使用条形显示维度的数值。纵轴显示分类维度，横轴显示相应的值。' },
        grouped_bar_chart: {
          name: '分组条形图',
          alias: ['簇状条形图'],
          def: '使用颜色不同的条形并排组成小组来显示维度的数值。纵轴标示出分组，颜色标示出分类，横轴显示相应的值。',
        },
        stacked_bar_chart: {
          name: '堆叠条形图',
          alias: [],
          def: '使用颜色不同的堆叠的条形来显示各维度的数值。纵轴标示出第一个分类维度，颜色标示出第二个分类维度，横轴显示相应的值。',
        },
        percent_stacked_bar_chart: {
          name: '百分比堆叠条形图',
          alias: ['%堆叠条形图', '100%堆叠条形图'],
          def: '使用颜色不同的堆叠的条形来显示各维度的数值。纵轴标示出第一个分类维度，颜色标示出第二个分类维度，横轴显示相应分类所占的百分比。',
        },
        interval_bar_chart: { name: '', alias: [], def: 'TBD' },
        range_bar_chart: { name: '区间条形图', alias: [], def: '区间条形图是一种特殊的条形图，条不一定要从 0 开始，而是用长度表示一个从起始值到终止值的区间。' },
        radial_bar_chart: { name: '', alias: [], def: 'TBD' },
        mirror_bar_chart: { name: '', alias: [], def: 'TBD' },
        bullet_chart: { name: '子弹图', alias: ['靶心图', '标靶图'], def: '子弹图可用于将度量的绩效可视化并与目标值和定性刻度。' },
        pie_chart: { name: '饼图', alias: [], def: '通过扇形区块的颜色和弧长（角度、面积）来展现数据的分类和占比情况。' },
        donut_chart: { name: '环图', alias: ['甜甜圈图'], def: '通过弧形区块的颜色和弧长来展现数据的分类和占比情况。' },
        nested_pie_chart: { name: '', alias: [], def: 'TBD' },
        rose_chart: {
          name: '玫瑰图',
          alias: ['南丁格尔图', '鸡冠花图', '极坐标面积图'],
          def: '统计学家和医学改革家佛罗伦萨‧南丁格尔在克里米亚战争期间创造了这种图表。尽管外形很像饼图，但本质上来说，南丁格尔玫瑰图更像在极坐标下绘制的柱状图或堆叠柱状图。只不过，它用半径来反映数值。',
        },
        scatter_plot: { name: '散点图', alias: [], def: '散点图是将所有的数据以不同颜色的点的形式展现在平面直角坐标系上的统计图表。' },
        bubble_chart: { name: '气泡图', alias: [], def: '气泡图是一种多变量的统计图表，由笛卡尔坐标系（直角坐标系）和大小不一、颜色不同的圆组成，可以看作是散点图的变形。' },
        non_ribbon_chord_diagram: { name: '', alias: [], def: 'TBD' },
        arc_diagram: { name: '弧形图', alias: [], def: '弧形图是一种关系图的特殊布局，节点被排列在同一水平线上，关系由节点间的圆弧线表示。' },
        chord_diagram: { name: '', alias: [], def: 'TBD' },
        treemap: { name: '', alias: [], def: 'TBD' },
        sankey_diagram: { name: '桑基图', alias: ['桑吉图'], def: '桑基图，是一种表现流程的示意图，用于描述一组值到另一组值的流向。分支的宽度对应了数据流量的大小。' },
        funnel_chart: { name: '漏斗图', alias: [], def: '漏斗图，形如“漏斗”，用于单流程分析，在开始和结束之间由N个流程环节组成。' },
        overlapping_funnel_chart: { name: '', alias: [], def: 'TBD' },
        mirror_funnel_chart: { name: '对比漏斗图', alias: ['对称漏斗图', '镜像漏斗图'], def: '对比漏斗图是两个独立的漏斗图以一根中轴线对称展开的图表形式。' },
        boxplot: { name: '', alias: [], def: 'TBD' },
        heatmap: { name: '热力图', alias: ['区块热力图'], def: '热力图，是一种通过对色块着色来显示数据的统计图表。' },
        density_heatmap: { name: '密度热力图', alias: ['热力图'], def: '密度热力图是一种用在连续坐标系上用色点展现密度分布的统计图表。' },
        gauge_chart: { name: '', alias: [], def: 'TBD' },
        radar_chart: {
          name: '雷达图',
          alias: ['蛛网图'],
          def: '将不同系列的多个维度的数据量映射到坐标轴上，这些坐标轴起始于同一个圆心点，通常结束于圆周边缘，将同一组的点使用线连接起来，用颜色区分系列。',
        },
        wordcloud: { name: '', alias: [], def: 'TBD' },
        candlestick_chart: { name: '', alias: [], def: 'TBD' },
        compact_box_tree: { name: '紧凑树', alias: [], def: '紧凑树是一种树图布局，从根节点开始，同一深度的节点在同一层，并且布局时会将节点大小考虑进去。' },
        dendrogram: { name: '生态树', alias: [], def: '生态树是一种树图布局，不管数据的深度多少，总是叶节点对齐。不考虑节点大小，布局时将节点视为 1 个像素点。' },
        indented_tree: { name: '缩进树', alias: [], def: '缩进树是一种树图布局，缩进树布局。每个元素会占一行/一列。' },
        radial_tree: { name: '辐射树', alias: [], def: '辐射树是一种树图布局，跟节点位于辐射树中心，其他分支辐射式展开。' },
        flow_diagram: { name: '流程图', alias: [], def: '流程图是一种图解，可视表示在过程或功能内部诸如事件、步骤等之间的顺序关系。' },
        fruchterman_layout_graph: { name: 'Fruchterman 布局力导向图', alias: [], def: '一种使用 Fruchterman 布局算法的力导向图。' },
        force_directed_layout_graph: {
          name: '力导向图',
          alias: [],
          def: '力导向图布局作为较早被发明的一种实际应用布局算法，经过研究者多年改进、扩展，已发展成为一类算法的集合。该类算法的特点是模拟物理世界中的作用力，施加在节点上，并迭代计算以达到合理放置节点、美观布局的一类算法。',
        },
        circular_layout_graph: { name: '环形布局关系图', alias: [], def: '环形布局根据参数指定的排序方式对节点进行排序后，将节点排列在圆环上。' },
        spiral_layout_graph: { name: '螺旋布局关系图', alias: [], def: '螺旋布局图的节点排列在一根螺旋线上。' },
        radial_layout_graph: {
          name: '辐射布局关系图',
          alias: [],
          def: '辐射布局根据指定的中心点，根据其他节点与中心点的拓扑距离（最短路径长度）将其余节点放置在以中心点为圆心的同心圆上。',
        },
        concentric_layout_graph: { name: '同心圆布局关系图', alias: [], def: '同心圆布局关系图将所有节点放置在同心圆上。' },
        grid_layout_graph: { name: '网格布局关系图', alias: [], def: '网格布局根据参数指定的排序方式对节点进行排序后，将节点排列在网格上。' },
        symbol_map: {
          name: '符号地图',
          alias: [],
          def: '散点地图的变体，用具象的图标指代抽象的圆点，无需图例就能直观看出数据点代表的内容，常用于地图上重要地标的显示或数据量较少时的信息表达。',
        },
        chart_map: { name: '复合图表地图', alias: [], def: '是定点地图的变体，使用二维统计图表代替点状符号的一种特殊复合形式。' },
        column_map_3d: { name: '3D 柱状图', alias: [], def: '用形状大小相同的柱状体代替点状符号，高度与数值大小映射共同表达离散现象分布特征的地图' },
        scatter_map: { name: '散点地图', alias: [], def: '指地图上可用一个形状大小相同的圆点来定位，用表达离散现象分布特征的地图，如人口、农作物、动植物等的分布' },
        path_map: { name: '路径地图', alias: [], def: '指需要用一连串首尾不闭合的点坐标对（xi,yi）来定位的一类图层。属于半依比例图层，线端点依附地图比例缩放，但线的粗细不会变化。' },
        isoline_map: { name: '等值线地图', alias: [], def: 'TBD' },
        arc_map_3d: {
          name: '3D 弧线地图',
          alias: [],
          def: '将两个点的连线绘制成弧形，绘制的弧线可以是贝塞尔曲线，大圆航线，通常用来表示两种地理事物关系和联系，或者人口迁移，物流起点目的地等。',
        },
        choropleth_map: { name: '填充地图', alias: [], def: '填充图，也叫分级统计图，可在地图上不同领土区域进行着色，查看区域间的分布对比情况' },
        choropleth_map_3d: { name: '3D 填充地图', alias: [], def: '填充地图的增强实现，通过三维视角中的高度模拟真实地物的高度。' },
        hexagonal_heat_map: {
          name: '蜂窝热力地图',
          alias: [],
          def: '使用六边形将地图区域进行分割，计算每个区域中点数或其他累加值，将离散的点转换为数值。然后将数值映射到每个区域的色值、高度或其他参数',
        },
        hexagonal_heat_map_3d: {
          name: '3D 蜂窝热力地图',
          alias: [],
          def: '使用3D 六边形将地图区域进行分割，计算每个区域中点数或其他累加值，将离散的点转换为数值。然后将数值映射到每个区域的色值、高度或其他参数',
        },
        classical_heat_map: { name: '热力地图', alias: [], def: '密度热力图是一种用在连续坐标系上用色点展现密度分布的统计地图。' },
        grid_heat_map: {
          name: '网格热力地图',
          alias: [],
          def: '使用网格区域进行分割，计算每个区域中点数或其他累加值，将离散的点转换为数值。然后将数值映射到每个区域的色值、高度或其他参数',
        },
        bubble_map: { name: '气泡地图', alias: [], def: '指地图上用一个形状相同、面积大小和数值成正比的圆点来定位的地图，是散点图的扩展，用于表达离散现象分布特征的地图。' },
        bubble_light_map: {
          name: '亮点地图',
          alias: [],
          def: '散点图的变形，指用一个点代表一个值，连续渐进颜色代表数值大小，并通过色彩的叠加的达到效果增强，专为海量散点数据运用而生，解决远视角下，点颜色无法区分问题',
        },
        packed_circles: { name: '', alias: [], def: 'TBD' },
        polar_treemap: { name: '', alias: [], def: 'TBD' },
        sunburst_diagram: { name: '', alias: [], def: 'TBD' },
        liquid_chart: { name: '水波图', alias: ['进度球'], def: '一种用来表示进度的拟物化示意图' },
      },
    },
  };

  function r(e) {
    return e && Object.keys(n).includes(e) ? n[e] : null;
  }

  var i = {
    line_chart: {
      id: 'line_chart',
      name: 'Line Chart',
      alias: ['Lines'],
      family: ['LineCharts'],
      def: 'A line chart uses lines with segments to show changes in data in a ordinal dimension.',
      purpose: ['Comparison', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Lines'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Time', 'Ordinal'] }, {
        minQty: 0,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }, { minQty: 1, maxQty: 1, fieldConditions: ['Interval'] }],
      channel: ['Position', 'Direction'],
      recRate: 'Recommended',
    },
    step_line_chart: {
      id: 'step_line_chart',
      name: 'Step Line Chart',
      alias: ['Step Lines'],
      family: ['LineCharts'],
      def: 'A step line chart is a line chart in which points of each line are connected by horizontal and vertical line segments, looking like steps of a staircase.',
      purpose: ['Comparison', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Lines'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Time', 'Ordinal'] }, {
        minQty: 0,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }, { minQty: 1, maxQty: 1, fieldConditions: ['Interval'] }],
      channel: ['Position', 'Direction'],
      recRate: 'Recommended',
    },
    area_chart: {
      id: 'area_chart',
      name: 'Area Chart',
      alias: [],
      family: ['AreaCharts'],
      def: 'An area chart uses series of line segments with overlapped areas to show the change in data in a ordinal dimension.',
      purpose: ['Comparison', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Area'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Time', 'Ordinal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }, { minQty: 0, maxQty: 1, fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    stacked_area_chart: {
      id: 'stacked_area_chart',
      name: 'Stacked Area Chart',
      alias: [],
      family: ['AreaCharts'],
      def: 'A stacked area chart uses layered line segments with different styles of padding regions to display how multiple sets of data change in the same ordinal dimension, and the endpoint heights of the segments on the same dimension tick are accumulated by value.',
      purpose: ['Comparison', 'Composition', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Area'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Time', 'Ordinal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }, { minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Length'],
      recRate: 'Recommended',
    },
    percent_stacked_area_chart: {
      id: 'percent_stacked_area_chart',
      name: 'Percent Stacked Area Chart',
      alias: ['Percent Stacked Area', '% Stacked Area', '100% Stacked Area'],
      family: ['AreaCharts'],
      def: 'A percent stacked area chart is an extented stacked area chart in which the height of the endpoints of the line segment on the same dimension tick is the accumulated proportion of the ratio, which is 100% of the total.',
      purpose: ['Comparison', 'Composition', 'Proportion', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Area'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Time', 'Ordinal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }, { minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Length'],
      recRate: 'Recommended',
    },
    interval_area_chart: {
      id: 'interval_area_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    stream_chart: {
      id: 'stream_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    column_chart: {
      id: 'column_chart',
      name: 'Column Chart',
      alias: ['Columns'],
      family: ['ColumnCharts'],
      def: 'A column chart uses series of columns to display the value of the dimension. The horizontal axis shows the classification dimension and the vertical axis shows the corresponding value.',
      purpose: ['Comparison', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 1, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Position', 'Color'],
      recRate: 'Recommended',
    },
    grouped_column_chart: {
      id: 'grouped_column_chart',
      name: 'Grouped Column Chart',
      alias: ['Grouped Column'],
      family: ['ColumnCharts'],
      def: 'A grouped column chart uses columns of different colors to form a group to display the values ​​of dimensions. The horizontal axis indicates the grouping of categories, the color indicates the categories, and the vertical axis shows the corresponding value.',
      purpose: ['Comparison', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    stacked_column_chart: {
      id: 'stacked_column_chart',
      name: 'Stacked Column Chart',
      alias: ['Stacked Column'],
      family: ['ColumnCharts'],
      def: 'A stacked column chart uses stacked bars of different colors to display the values ​​for each dimension. The horizontal axis indicates the first classification dimension, the color indicates the second classification dimension, and the vertical axis shows the corresponding value.',
      purpose: ['Comparison', 'Composition', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length', 'Position'],
      recRate: 'Recommended',
    },
    percent_stacked_column_chart: {
      id: 'percent_stacked_column_chart',
      name: 'Percent Stacked Column Chart',
      alias: ['Percent Stacked Column', '% Stacked Column', '100% Stacked Column'],
      family: ['ColumnCharts'],
      def: 'A percent stacked column chart uses stacked bars of different colors to display the values ​​for each dimension. The horizontal axis indicates the first classification dimension, the color indicates the second classification dimension, and the vertical axis shows the percentage of the corresponding classification.',
      purpose: ['Comparison', 'Composition', 'Distribution', 'Proportion'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length'],
      recRate: 'Recommended',
    },
    interval_column_chart: {
      id: 'interval_column_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    range_column_chart: {
      id: 'range_column_chart',
      name: 'Range Column Chart',
      alias: [],
      family: ['ColumnCharts'],
      def: 'A column chart that does not have to start from zero axis.',
      purpose: ['Comparison'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Interval'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }],
      channel: ['Length'],
      recRate: 'Recommended',
    },
    waterfall_chart: {
      id: 'waterfall_chart',
      name: 'Waterfall Chart',
      alias: ['Flying Bricks Chart', 'Mario Chart', 'Bridge Chart', 'Cascade Chart'],
      family: ['ColumnCharts'],
      def: 'A waterfall chart is used to portray how an initial value is affected by a series of intermediate positive or negative values',
      purpose: ['Comparison', 'Trend'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Ordinal', 'Time', 'Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length', 'Position'],
      recRate: 'Recommended',
    },
    histogram: {
      id: 'histogram',
      name: 'Histogram',
      alias: [],
      family: ['ColumnCharts'],
      def: 'A histogram is an accurate representation of the distribution of numerical data.',
      purpose: ['Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Interval'] }],
      channel: ['Position'],
      recRate: 'Recommended',
    },
    bar_chart: {
      id: 'bar_chart',
      name: 'Bar Chart',
      alias: ['Bars'],
      family: ['BarCharts'],
      def: 'A bar chart uses series of bars to display the value of the dimension. The vertical axis shows the classification dimension and the horizontal axis shows the corresponding value.',
      purpose: ['Comparison', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 1, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Position', 'Color'],
      recRate: 'Recommended',
    },
    grouped_bar_chart: {
      id: 'grouped_bar_chart',
      name: 'Grouped Bar Chart',
      alias: ['Grouped Bar'],
      family: ['BarCharts'],
      def: 'A grouped bar chart uses bars of different colors to form a group to display the values of the dimensions. The vertical axis indicates the grouping of categories, the color indicates the categories, and the horizontal axis shows the corresponding value.',
      purpose: ['Comparison', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    stacked_bar_chart: {
      id: 'stacked_bar_chart',
      name: 'Stacked Bar Chart',
      alias: ['Stacked Bar'],
      family: ['BarCharts'],
      def: 'A stacked bar chart uses stacked bars of different colors to display the values ​​for each dimension. The vertical axis indicates the first classification dimension, the color indicates the second classification dimension, and the horizontal axis shows the corresponding value.',
      purpose: ['Comparison', 'Composition', 'Distribution', 'Rank'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length', 'Position'],
      recRate: 'Recommended',
    },
    percent_stacked_bar_chart: {
      id: 'percent_stacked_bar_chart',
      name: 'Percent Stacked Bar Chart',
      alias: ['Percent Stacked Bar', '% Stacked Bar', '100% Stacked Bar'],
      family: ['BarCharts'],
      def: 'A percent stacked column chart uses stacked bars of different colors to display the values ​​for each dimension. The vertical axis indicates the first classification dimension, the color indicates the second classification dimension, and the horizontal axis shows the percentage of the corresponding classification.',
      purpose: ['Comparison', 'Composition', 'Distribution', 'Proportion'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length'],
      recRate: 'Recommended',
    },
    interval_bar_chart: {
      id: 'interval_bar_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    range_bar_chart: {
      id: 'range_bar_chart',
      name: 'Range Bar Chart',
      alias: [],
      family: ['BarCharts'],
      def: 'A bar chart that does not have to start from zero axis.',
      purpose: ['Comparison'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Interval'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }],
      channel: ['Length'],
      recRate: 'Recommended',
    },
    radial_bar_chart: {
      id: 'radial_bar_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    mirror_bar_chart: {
      id: 'mirror_bar_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    bullet_chart: {
      id: 'bullet_chart',
      name: 'Bullet Chart',
      alias: [],
      family: ['BarCharts'],
      def: 'A bullet graph is a variation of a bar graph developed by Stephen Few. Seemingly inspired by the traditional thermometer charts and progress bars found in many dashboards, the bullet graph serves as a replacement for dashboard gauges and meters.',
      purpose: ['Proportion'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Bars'],
      dataPres: [{ minQty: 3, maxQty: 3, fieldConditions: ['Interval'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }],
      channel: ['Position', 'Color'],
      recRate: 'Recommended',
    },
    pie_chart: {
      id: 'pie_chart',
      name: 'Pie Chart',
      alias: ['Circle Chart', 'Pie'],
      family: ['PieCharts'],
      def: 'A pie chart is a chart that the classification and proportion of data are represented by the color and arc length (angle, area) of the sector.',
      purpose: ['Comparison', 'Composition', 'Proportion'],
      coord: ['Polar'],
      category: ['Statistic'],
      shape: ['Round'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Angle', 'Area', 'Color'],
      recRate: 'Use with Caution',
    },
    donut_chart: {
      id: 'donut_chart',
      name: 'Donut Chart',
      alias: ['Donut', 'Doughnut', 'Doughnut Chart', 'Ring Chart'],
      family: ['PieCharts'],
      def: 'A donut chart is a variation on a Pie chart except it has a round hole in the center which makes it look like a donut.',
      purpose: ['Comparison', 'Composition', 'Proportion'],
      coord: ['Polar'],
      category: ['Statistic'],
      shape: ['Round'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['ArcLength'],
      recRate: 'Recommended',
    },
    nested_pie_chart: {
      id: 'nested_pie_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    rose_chart: {
      id: 'rose_chart',
      name: 'Rose Chart',
      alias: ['Nightingale Chart', 'Polar Area Chart', 'Coxcomb Chart'],
      family: ['PieCharts'],
      def: 'Nightingale Rose Chart is a peculiar combination of the Radar Chart and Stacked Column Chart types of data visualization.',
      purpose: ['Comparison', 'Composition', 'Proportion'],
      coord: ['Polar'],
      category: ['Statistic'],
      shape: ['Round'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Angle', 'Color', 'Length'],
      recRate: 'Use with Caution',
    },
    scatter_plot: {
      id: 'scatter_plot',
      name: 'Scatter Plot',
      alias: ['Scatter Chart', 'Scatterplot'],
      family: ['ScatterCharts'],
      def: 'A scatter plot is a type of plot or mathematical diagram using Cartesian coordinates to display values for typically two variables for series of data.',
      purpose: ['Comparison', 'Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Scatter'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Interval'] }, {
        minQty: 0,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    bubble_chart: {
      id: 'bubble_chart',
      name: 'Bubble Chart',
      alias: ['Bubble Chart'],
      family: ['ScatterCharts'],
      def: 'A bubble chart is a type of chart that displays four dimensions of data with x, y positions, circle size and circle color.',
      purpose: ['Comparison', 'Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Scatter'],
      dataPres: [{ minQty: 3, maxQty: 3, fieldConditions: ['Interval'] }, {
        minQty: 0,
        maxQty: 1,
        fieldConditions: ['Nominal'],
      }],
      channel: ['Color', 'Position', 'Size'],
      recRate: 'Recommended',
    },
    mechanical_bubble_chart: {
      id: 'mechanical_bubble_chart',
      name: 'Mechanical Bubble Chart',
      alias: ['Bubble Chart'],
      family: ['ScatterCharts'],
      def:
        'Mechanical Bubble Chart',
      purpose: ['Comparison', 'Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Scatter'],
      dataPres: [
        { minQty: 1, maxQty: 1, fieldConditions: ['Interval'] },
        { minQty: 1, maxQty: 2, fieldConditions: ['Nominal'] },
      ],
      channel: ['Color', 'Position', 'Size'],
      recRate: 'Recommended',
    },
    non_ribbon_chord_diagram: {
      id: 'non_ribbon_chord_diagram',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    arc_diagram: {
      id: 'arc_diagram',
      name: 'Arc Diagram',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A graph where the edges are represented as arcs.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    chord_diagram: {
      id: 'chord_diagram',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    treemap: {
      id: 'treemap',
      name: 'Treemap',
      alias: ['Web Chart', 'Spider Chart', 'Star Chart'],
      family: ['TreeGraph'],
      def: 'treemap',
      purpose: ['Hierarchy', 'Relation'],
      coord: ['Polar'],
      category: ['Statistic'],
      shape: ['Square'],
      dataPres: [
        { minQty: 1, maxQty: 2, fieldConditions: ['Nominal'] },
        { minQty: 1, maxQty: 1, fieldConditions: ['Interval'] },
      ],
      channel: ['Position', 'Size'],
      recRate: 'Recommended',
    },
    sankey_diagram: {
      id: 'sankey_diagram',
      name: 'Sankey Diagram',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A graph shows the flows with weights between objects.',
      purpose: ['Flow', 'Trend', 'Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    funnel_chart: {
      id: 'funnel_chart',
      name: 'Funnel Chart',
      alias: [],
      family: ['FunnelCharts'],
      def: 'A funnel chart is often used to represent stages in a sales process and show the amount of potential revenue for each stage.',
      purpose: ['Trend'],
      coord: ['SymmetricCartesian'],
      category: ['Statistic'],
      shape: ['Symmetric'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Length'],
      recRate: 'Recommended',
    },
    overlapping_funnel_chart: {
      id: 'overlapping_funnel_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    mirror_funnel_chart: {
      id: 'mirror_funnel_chart',
      name: 'Mirror Funnel Chart',
      alias: ['Contrast Funnel Chart'],
      family: ['FunnelCharts'],
      def: 'A mirror funnel chart is a funnel chart divided into two series by a central axis.',
      purpose: ['Comparison', 'Trend'],
      coord: ['SymmetricCartesian'],
      category: ['Statistic'],
      shape: ['Symmetric'],
      dataPres: [{ minQty: 1, maxQty: 1, fieldConditions: ['Ordinal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }, { minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Length', 'Direction'],
      recRate: 'Recommended',
    },
    boxplot: {
      id: 'boxplot',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    heatmap: {
      id: 'heatmap',
      name: 'Heatmap',
      alias: [],
      family: ['HeatmapCharts'],
      def: 'A heatmap is a graphical representation of data where the individual values contained in a matrix are represented as colors.',
      purpose: ['Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Square'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Nominal', 'Ordinal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    density_heatmap: {
      id: 'density_heatmap',
      name: 'Density Heatmap',
      alias: ['Heatmap'],
      family: ['HeatmapCharts'],
      def: 'A density heatmap is a heatmap for representing the density of dots.',
      purpose: ['Distribution'],
      coord: ['Cartesian2D'],
      category: ['Statistic'],
      shape: ['Area'],
      dataPres: [{ minQty: 3, maxQty: 3, fieldConditions: ['Interval'] }],
      channel: ['Color', 'Position', 'Area'],
      recRate: 'Recommended',
    },
    gauge_chart: {
      id: 'gauge_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    radar_chart: {
      id: 'radar_chart',
      name: 'Radar Chart',
      alias: ['Web Chart', 'Spider Chart', 'Star Chart', 'Cobweb Chart', 'Irregular Polygon', 'Kiviat diagram'],
      family: ['RadarCharts'],
      def: 'A radar chart maps series of data volume of multiple dimensions onto the axes. Starting at the same center point, usually ending at the edge of the circle, connecting the same set of points using lines.',
      purpose: ['Comparison'],
      coord: ['Radar'],
      category: ['Statistic'],
      shape: ['Round'],
      dataPres: [{ minQty: 1, maxQty: 2, fieldConditions: ['Nominal'] }, {
        minQty: 1,
        maxQty: 1,
        fieldConditions: ['Interval'],
      }],
      channel: ['Color', 'Position'],
      recRate: 'Recommended',
    },
    wordcloud: {
      id: 'wordcloud',
      name: 'Wordcloud',
      alias: ['Web Chart', 'Spider Chart', 'Star Chart'],
      family: ['Others'],
      def: 'wordcloud',
      purpose: ['Comparison', 'Composition'],
      coord: ['Polar'],
      category: ['Statistic'],
      shape: ['Round'],
      dataPres: [
        { minQty: 1, maxQty: 1, fieldConditions: ['Nominal'] },
        { minQty: 1, maxQty: 1, fieldConditions: ['Interval'] },
      ],
      channel: ['Color', 'Size'],
      recRate: 'Recommended',
    },
    candlestick_chart: {
      id: 'candlestick_chart',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    compact_box_tree: {
      id: 'compact_box_tree',
      name: 'CompactBox Tree',
      alias: [],
      family: ['TreeGraph'],
      def: 'A type of tree graph layout which arranges the nodes with same depth on the same level.',
      purpose: ['Relation', 'Hierarchy'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    dendrogram: {
      id: 'dendrogram',
      name: 'Dendrogram',
      alias: [],
      family: ['TreeGraph'],
      def: 'A type of tree graph layout which arranges the leaves on the same level and ignores the node size.',
      purpose: ['Relation', 'Hierarchy'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    indented_tree: {
      id: 'indented_tree',
      name: 'Indented Tree Layout',
      alias: [],
      family: ['TreeGraph'],
      def: 'A type of tree graph layout where each node takes a row or a column.',
      purpose: ['Relation', 'Hierarchy'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    radial_tree: {
      id: 'radial_tree',
      name: 'Radial Tree Layout',
      alias: [],
      family: ['TreeGraph'],
      def: 'A type of tree graph layout which places the root at the center, and the branches around the root radially.',
      purpose: ['Relation', 'Hierarchy'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    flow_diagram: {
      id: 'flow_diagram',
      name: 'Flow Diagram',
      alias: ['Dagre Graph Layout', 'Dagre', 'Flow Chart'],
      family: ['GeneralGraph'],
      def: 'Directed flow graph.',
      purpose: ['Relation', 'Flow'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    fruchterman_layout_graph: {
      id: 'fruchterman_layout_graph',
      name: 'Fruchterman Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of force directed graph layout.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    force_directed_layout_graph: {
      id: 'force_directed_layout_graph',
      name: 'Force Directed Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'The classical force directed graph layout.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    circular_layout_graph: {
      id: 'circular_layout_graph',
      name: 'Circular Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of graph layout which arranges all the nodes on a circle.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    spiral_layout_graph: {
      id: 'spiral_layout_graph',
      name: 'Spiral Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of graph layout which arranges all the nodes along a spiral line.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    radial_layout_graph: {
      id: 'radial_layout_graph',
      name: 'Radial Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of graph layout which places a focus node on the center and the others on the concentrics centered at the focus node according to the shortest path length to the it.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    concentric_layout_graph: {
      id: 'concentric_layout_graph',
      name: 'Concentric Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of graph layout which arranges the nodes on concentrics.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    grid_layout_graph: {
      id: 'grid_layout_graph',
      name: 'Grid Graph Layout',
      alias: [],
      family: ['GeneralGraph'],
      def: 'A type of graph layout arranges the nodes on grids.',
      purpose: ['Relation'],
      coord: ['Cartesian2D'],
      category: ['Graph'],
      shape: ['Network'],
      dataPres: [{ minQty: 1, maxQty: '*', fieldConditions: ['Nominal'] }],
      channel: ['Color', 'Size', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    symbol_map: {
      id: 'symbol_map',
      name: 'Symbol Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Overlay symbols on the map as glyphs.',
      purpose: ['Distribution', 'Comparison', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Scatter', 'Map'],
      dataPres: [],
      channel: ['Position'],
      recRate: 'Recommended',
    },
    chart_map: {
      id: 'chart_map',
      name: 'Chart Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Overlay charts on the map as glyphs.',
      purpose: ['Composition', 'Distribution', 'Comparison', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Map'],
      dataPres: [],
      channel: ['Position'],
      recRate: 'Recommended',
    },
    column_map_3d: {
      id: 'column_map_3d',
      name: '3D Column Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Maps that use height of 3D columns to represent distribution.',
      purpose: ['Distribution', 'Comparison', 'Spatial'],
      coord: [],
      category: ['Map'],
      shape: ['Map'],
      dataPres: [],
      channel: ['Position', 'Length'],
      recRate: 'Recommended',
    },
    scatter_map: {
      id: 'scatter_map',
      name: 'Scatter Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Overlay dots with same size on the map as glyphs.',
      purpose: ['Distribution', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Scatter', 'Map'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    path_map: {
      id: 'path_map',
      name: 'Path Map',
      alias: [],
      family: ['LineLayer'],
      def: 'Overlay paths on the map as glyphs.',
      purpose: ['Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Lines'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    isoline_map: {
      id: 'isoline_map',
      name: 'Isoline Map',
      alias: [],
      family: ['LineLayer'],
      def: '',
      purpose: ['Comparison'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Lines'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    arc_map_3d: {
      id: 'arc_map_3d',
      name: '3D Arc Map',
      alias: [],
      family: ['LineLayer'],
      def: '',
      purpose: ['Relation', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Lines'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    choropleth_map: {
      id: 'choropleth_map',
      name: 'Choropleth Map',
      alias: [],
      family: ['PolygonLayer'],
      def: 'A choropleth map is a type of thematic map in which areas are shaded or patterned in proportion to a statistical variable that represents an aggregate summary of a geographic characteristic within each area, such as population density or per-capita income.',
      purpose: ['Comparison', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Area', 'Map'],
      dataPres: [],
      channel: ['Color', 'Position', 'Opacity', 'Stroke', 'LineWidth'],
      recRate: 'Recommended',
    },
    choropleth_map_3d: {
      id: 'choropleth_map_3d',
      name: '3D Choropleth Map',
      alias: ['Extrude Map'],
      family: ['PolygonLayer'],
      def: '',
      purpose: ['Comparison'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Area', 'Map'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    hexagonal_heat_map: {
      id: 'hexagonal_heat_map',
      name: 'Hexagonal Heat Map',
      alias: [],
      family: [],
      def: 'Dividing the map area using hexagons.',
      purpose: ['Distribution', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Area', 'Map'],
      dataPres: [],
      channel: ['Size', 'Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    hexagonal_heat_map_3d: {
      id: 'hexagonal_heat_map_3d',
      name: '3D Hexagonal Heat Map',
      alias: [],
      family: [],
      def: 'Dividing the 3D map area using hexagons.',
      purpose: ['Distribution'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Map'],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    classical_heat_map: {
      id: 'classical_heat_map',
      name: 'Classical Heat Map',
      alias: [],
      family: [],
      def: '',
      purpose: ['Distribution'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Map'],
      dataPres: [],
      channel: ['Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    grid_heat_map: {
      id: 'grid_heat_map',
      name: 'Gird Heat Map',
      alias: [],
      family: [],
      def: '',
      purpose: ['Distribution'],
      coord: [],
      category: ['Map'],
      shape: ['Map'],
      dataPres: [],
      channel: ['Color', 'Position', 'Opacity'],
      recRate: 'Recommended',
    },
    bubble_map: {
      id: 'bubble_map',
      name: 'Bubble Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Overlay bubbles on the map as glyphs.',
      purpose: ['Distribution', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Scatter', 'Map'],
      dataPres: [],
      channel: ['Position', 'Color', 'Size'],
      recRate: 'Recommended',
    },
    bubble_light_map: {
      id: 'bubble_light_map',
      name: 'Bubble Light Map',
      alias: [],
      family: ['PointLayer'],
      def: 'Overlay bubbles with different lightness on the map as glyphs.',
      purpose: ['Distribution', 'Spatial'],
      coord: ['Geo'],
      category: ['Map'],
      shape: ['Scatter', 'Map'],
      dataPres: [],
      channel: ['Position', 'Color', 'Size', 'Opacity'],
      recRate: 'Recommended',
    },
    packed_circles: {
      id: 'packed_circles',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    polar_treemap: {
      id: 'polar_treemap',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    sunburst_diagram: {
      id: 'sunburst_diagram',
      name: '',
      alias: [],
      family: [],
      def: '',
      purpose: [],
      coord: [],
      category: [],
      shape: [],
      dataPres: [],
      channel: [],
      recRate: 'Recommended',
    },
    liquid_chart: {
      id: 'liquid_chart',
      name: 'Liquid Chart',
      alias: ['Liquid Ball', 'Progress Ball'],
      family: ['Others'],
      def: 'Liquid chart is a diagram to represent progress.',
      purpose: ['Composition'],
      coord: ['Other'],
      category: ['Diagram'],
      shape: ['Round'],
      dataPres: [{ minQty: 2, maxQty: 2, fieldConditions: ['Interval'] }],
      channel: ['Position'],
      recRate: 'Not Recommended',
    },
  };

  function o(e, a) {
    void 0 === e && (e = 'en-US'), void 0 === a && (a = !1);
    var t = JSON.parse(JSON.stringify(i)), n = {};
    Object.keys(t).forEach((function(e) {
      var r = t[e], i = !0;
      if (a) for (var o = Object.keys(r), c = 0; c < o.length; c++) {
        var s = o[c], l = r[s];
        if ('alias' !== s && 'boolean' != typeof l && (Array.isArray(l) && 0 === l.length || !l)) {
          i = !1;
          break;
        }
      }
      i && (n[e] = r);
    }));
    var o = {};
    if (e && 'en-US' != e) {
      var c = r(e), s = Object.keys(n);
      c && s.forEach((function(e) {
        o[e] = {}, o[e].id = e, o[e].name = c.chartTypes[e].name, o[e].alias = c.chartTypes[e].alias, o[e].def = c.chartTypes[e].def, o[e].family = n[e].family.map((function(e) {
          return c.concepts.family[e];
        })), o[e].purpose = n[e].purpose.map((function(e) {
          return c.concepts.purpose[e];
        })), o[e].coord = n[e].coord.map((function(e) {
          return c.concepts.coord[e];
        })), o[e].category = n[e].category.map((function(e) {
          return c.concepts.category[e];
        })), o[e].shape = n[e].shape.map((function(e) {
          return c.concepts.shape[e];
        })), o[e].channel = n[e].channel.map((function(e) {
          return c.concepts.channel[e];
        })), o[e].dataPres = n[e].dataPres.map((function(e) {
          var a = {};
          return a.minQty = e.minQty, a.maxQty = e.maxQty, a.fieldConditions = e.fieldConditions.map((function(e) {
            return c.concepts.lom[e];
          })), a;
        }));
      }));
    } else o = n;
    return o;
  }

  var c = function() {
    return (c = Object.assign || function(e) {
      for (var a, t = 1, n = arguments.length; t < n; t++) for (var r in a = arguments[t]) Object.prototype.hasOwnProperty.call(a, r) && (e[r] = a[r]);
      return e;
    }).apply(this, arguments);
  };

  function s(e) {
    var a = 'function' == typeof Symbol && Symbol.iterator, t = a && e[a], n = 0;
    if (t) return t.call(e);
    if (e && 'number' == typeof e.length) return {
      next: function() {
        return e && n >= e.length && (e = void 0), { value: e && e[n++], done: !e };
      },
    };
    throw new TypeError(a ? 'Object is not iterable.' : 'Symbol.iterator is not defined.');
  }

  function l(e, a) {
    var t = 'function' == typeof Symbol && e[Symbol.iterator];
    if (!t) return e;
    var n, r, i = t.call(e), o = [];
    try {
      for (; (void 0 === a || a-- > 0) && !(n = i.next()).done;) o.push(n.value);
    } catch (e) {
      r = { error: e };
    } finally {
      try {
        n && !n.done && (t = i.return) && t.call(i);
      } finally {
        if (r) throw r.error;
      }
    }
    return o;
  }

  function d() {
    for (var e = [], a = 0; a < arguments.length; a++) e = e.concat(l(arguments[a]));
    return e;
  }

  function m(e, a) {
    for (var t = 0; t < a.length; t++) {
      var n = a[t];
      n.enumerable = n.enumerable || !1, n.configurable = !0, 'value' in n && (n.writable = !0), Object.defineProperty(e, n.key, n);
    }
  }

  function h(e, a, t) {
    return a in e ? Object.defineProperty(e, a, {
      value: t,
      enumerable: !0,
      configurable: !0,
      writable: !0,
    }) : e[a] = t, e;
  }

  var u = function() {
    function e(a, t, n, r, i) {
      !function(e, a) {
        if (!(e instanceof a)) throw new TypeError('Cannot call a class as a function');
      }(this, e), h(this, '_id', void 0), h(this, '_hardOrSoft', void 0), h(this, '_specChartTypes', void 0), h(this, '_weight', void 0), h(this, 'validator', void 0), this._id = a, this._hardOrSoft = t, this._specChartTypes = n, this._weight = r, this.validator = i;
    }

    var a, t, n;
    return a = e, (t = [{
      key: 'toString', value: function() {
        return 'RULE: '.concat(this._id, '^').concat(this._hardOrSoft, '^').concat(this._specChartTypes.toString(), '^*').concat(this.weight);
      },
    }, {
      key: 'check', value: function(e) {
        return this.validator(e) * this._weight;
      },
    }, {
      key: 'id', get: function() {
        return this._id;
      },
    }, {
      key: 'hardOrSoft', get: function() {
        return this._hardOrSoft;
      },
    }, {
      key: 'specChartTypes', get: function() {
        return this._specChartTypes;
      },
    }, {
      key: 'weight', get: function() {
        return this._weight;
      },
    }]) && m(a.prototype, t), n && m(a, n), e;
  }();

  function p(e, a) {
    var t;
    if ('undefined' == typeof Symbol || null == e[Symbol.iterator]) {
      if (Array.isArray(e) || (t = function(e, a) {
        if (!e) return;
        if ('string' == typeof e) return f(e, a);
        var t = Object.prototype.toString.call(e).slice(8, -1);
        'Object' === t && e.constructor && (t = e.constructor.name);
        if ('Map' === t || 'Set' === t) return Array.from(e);
        if ('Arguments' === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t)) return f(e, a);
      }(e)) || a && e && 'number' == typeof e.length) {
        t && (e = t);
        var n = 0, r = function() {
        };
        return {
          s: r, n: function() {
            return n >= e.length ? { done: !0 } : { done: !1, value: e[n++] };
          }, e: function(e) {
            throw e;
          }, f: r,
        };
      }
      throw new TypeError('Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.');
    }
    var i, o = !0, c = !1;
    return {
      s: function() {
        t = e[Symbol.iterator]();
      }, n: function() {
        var e = t.next();
        return o = e.done, e;
      }, e: function(e) {
        c = !0, i = e;
      }, f: function() {
        try {
          o || null == t.return || t.return();
        } finally {
          if (c) throw i;
        }
      },
    };
  }

  function f(e, a) {
    (null == a || a > e.length) && (a = e.length);
    for (var t = 0, n = new Array(a); t < a; t++) n[t] = e[t];
    return n;
  }

  var y = o('en-US', !0), g = Object.keys(y);

  function _(e, a) {
    return e.distinct < a.distinct ? 1 : e.distinct > a.distinct ? -1 : 0;
  }

  function v(e, a) {
    return a.every((function(a) {
      return e.includes(a);
    }));
  }

  function b(e, a) {
    return a.some((function(a) {
      return e.includes(a);
    }));
  }

  function C(e, a) {
    var t = a.map((function(e) {
      return e.levelOfMeasurements;
    }));
    if (t) {
      var n, r = 0, i = p(t);
      try {
        for (i.s(); !(n = i.n()).done;) {
          var o = n.value;
          o && b(o, e.fieldConditions) && (r += 1);
        }
      } catch (e) {
        i.e(e);
      } finally {
        i.f();
      }
      if (r >= e.minQty && (r <= e.maxQty || '*' === e.maxQty)) return !0;
    }
    return !1;
  }

  var x = [new u('data-check', 'HARD', g, 1, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && n && y[n]) {
        a = 1;
        var r, i = p(y[n].dataPres || []);
        try {
          for (i.s(); !(r = i.n()).done;) {
            if (!C(r.value, t)) return a = 0;
          }
        } catch (e) {
          i.e(e);
        } finally {
          i.f();
        }
      }
      return a;
    })), new u('data-field-qty', 'HARD', g, 1, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && n && y[n]) {
        a = 1;
        var r = (y[n].dataPres || []).map((function(e) {
          return e.minQty;
        })).reduce((function(e, a) {
          return e + a;
        }));
        if (t.length) t.length >= r && (a = 1);
      }
      return a;
    })), new u('no-redundant-field', 'HARD', g, 1, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && n && y[n]) {
        var r = (y[n].dataPres || []).map((function(e) {
          return '*' === e.maxQty ? 99 : e.maxQty;
        })).reduce((function(e, a) {
          return e + a;
        }));
        if (t.length) t.length <= r && (a = 1);
      }
      return a;
    })), new u('purpose-check', 'HARD', g, 1, (function(e) {
      var a = 0, t = e.chartType, n = e.purpose;
      if (!n) return a = 1;
      if (t && y[t] && n && (y[t].purpose || '').includes(n)) return a = 1;
      return a;
    })), new u('series-qty-limit', 'SOFT', ['pie_chart', 'donut_chart', 'rose_chart'], .8, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType, r = 6;
      if ('pie_chart' !== n && 'donut_chart' !== n && 'rose_chart' !== n || (r = 6), 'radar_chart' === n && (r = 8), t) {
        var i = t.find((function(e) {
          return v(e.levelOfMeasurements, ['Nominal']);
        })), o = i && i.count ? i.count : 0;
        o >= 2 && o <= r && (a = 2 / o);
      }
      return a;
    })), new u('bar-series-qty', 'SOFT', ['bar_chart', 'grouped_bar_chart', 'stacked_bar_chart', 'percent_stacked_bar_chart', 'column_chart', 'grouped_column_chart', 'stacked_column_chart', 'percent_stacked_column_chart'], .5, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && n) {
        var r = t.find((function(e) {
          return v(e.levelOfMeasurements, ['Nominal']);
        })), i = r && r.count ? r.count : 0;
        i >= 2 && i <= 20 ? a = 1 : i > 20 && (a = 20 / i);
      }
      return a;
    })), new u('line-field-time-ordinal', 'SOFT', ['line_chart', 'area_chart', 'stacked_area_chart', 'percent_stacked_area_chart'], 1, (function(e) {
      var a = 0, t = e.dataProps;
      t && (t.find((function(e) {
        return b(e.levelOfMeasurements, ['Ordinal', 'Time']);
      })) && (a = 1));
      return a;
    })), new u('landscape-or-portrait', 'SOFT', ['bar_chart', 'grouped_bar_chart', 'stacked_bar_chart', 'percent_stacked_bar_chart', 'column_chart', 'grouped_column_chart', 'stacked_column_chart', 'percent_stacked_column_chart'], .3, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType, r = e.preferences;
      return t && n && r && r.canvasLayout && ('portrait' === r.canvasLayout && ['bar_chart', 'grouped_bar_chart', 'stacked_bar_chart', 'percent_stacked_bar_chart'].includes(n) || 'landscape' === r.canvasLayout && ['column_chart', 'grouped_column_chart', 'stacked_column_chart', 'percent_stacked_column_chart'].includes(n)) && (a = 1), a;
    })), new u('diff-pie-sector', 'SOFT', ['pie_chart', 'donut_chart'], .5, (function(e) {
      var a = 0, t = e.dataProps;
      if (t) {
        var n = t.find((function(e) {
          return v(e.levelOfMeasurements, ['Interval']);
        }));
        if (n && n.sum && n.samples) {
          var r = 1 / n.sum, i = n.samples.map((function(e) {
            return e * r;
          })).reduce((function(e, a) {
            return e * a;
          })), o = n.samples.length, c = Math.pow(1 / o, o);
          a = Math.abs(c - Math.abs(i)) / c;
        }
      }
      return a;
    })), new u('nominal-enum-combinatorial', 'SOFT', g, 1, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && g) {
        var r = t.filter((function(e) {
          return v(e.levelOfMeasurements, ['Nominal']);
        }));
        if (r.length >= 2) {
          var i = r.sort(_), o = i[0], c = i[1];
          if (o.distinct === o.count && ['bar_chart', 'column_chart'].includes(n) && (a = 1), o.count && o.distinct && c.distinct && o.count >= o.distinct * c.distinct) {
            ['grouped_bar_chart', 'grouped_column_chart', 'stacked_bar_chart', 'stacked_column_chart'].includes(n) && (a = 1);
          }
        }
      }
      return a;
    })), new u('limit-series', 'SOFT', g, 1, (function(e) {
      var a = 0, t = e.dataProps, n = e.chartType;
      if (t && g) {
        var r = t.filter((function(e) {
          return b(e.levelOfMeasurements, ['Nominal', 'Ordinal']);
        }));
        if (r.length >= 2) {
          var i = r.sort(_)[1];
          i.distinct && (a = 1 / i.distinct, i.distinct > 6 && 'heatmap' === n ? a = 2 : 'heatmap' === n && (a = 0));
        }
      }
      return a;
    })), new u('first-dimension-limit', 'SOFT', ['funnel_chart', 'radar_chart', 'wordcloud'], .4, (function(e) {
      var a = e.dataProps, t = e.chartType, n = 3, r = 6;
      if ('radar_chart' === t ? (n = 4, r = 12) : 'wordcloud' === t && (n = 6, r = 20), a) {
        var i = a.filter((function(e) {
          return v(e.levelOfMeasurements, ['Nominal']);
        }));
        if (i.length >= 1) {
          var o = i.sort(_)[0];
          if (o.distinct && o.distinct >= n && o.distinct <= r) return 1;
        }
      }
      return 0;
    })), new u('second-dimension-limit', 'SOFT', ['radar_chart'], .3, (function(e) {
      var a = e.dataProps;
      if (a) {
        var t = a.filter((function(e) {
          return v(e.levelOfMeasurements, ['Nominal']);
        }));
        if (!(t.length > 1)) return 1;
        var n = t.sort(_)[1];
        if (n.distinct && n.distinct <= 2) return 1;
      }
      return 0;
    })), new u('diff-sector', 'SOFT', ['funnel_chart', 'wordcloud', 'treemap'], .3, (function(e) {
      var a = 0, t = e.dataProps;
      if (t) {
        var n = t.find((function(e) {
          return v(e.levelOfMeasurements, ['Interval']);
        }));
        if (n && n.sum && n.samples) {
          var r = 1 / n.sum, i = n.samples.map((function(e) {
            return e * r;
          })).reduce((function(e, a) {
            return e * a;
          })), o = n.samples.length, c = Math.pow(1 / o, o);
          a = Math.abs(c - Math.abs(i)) / c;
        }
      }
      return a;
    })), new u('data-count', 'SOFT', ['treemap', 'mechanical_bubble_chart'], .4, (function(e) {
      var a = e.dataProps;
      if (a) {
        var t = a.find((function(e) {
          return v(e.levelOfMeasurements, ['Interval']);
        }));
        if (t && t.count) {
          var n = t.count;
          if (n >= 6 && n <= 40) return 1;
        }
      }
      return 0;
    }))], R = '([-_./\\s])', P = '\\d{2,4}', S = '(0?[1-9]|1[012])', k = '(0?[1-9]|[12]\\d|3[01])',
    w = '(0?\\d|1\\d|2[0-4])', O = '(0?\\d|[012345]\\d)', Q = '(Z|[+-]' + w + '(:' + O + ')?)',
    D = ['' + P + R + '?W([0-4]\\d|5[0-2])(' + R + '?([1-7]))?', '' + S + R + '?' + k + R + '?' + P, '' + P + R + '?' + S + R + '?' + k, '' + P + R + S, '' + P + R + '?((([0-2]\\d|3[0-5])\\d)|36[0-6])'],
    M = [w + ':?' + O + ':?(0?\\d|[012345]\\d)([.,]\\d{1,4})?' + Q + '?', w + ':?' + O + '?' + Q], T = d(D, M);
  D.forEach((function(e) {
    M.forEach((function(a) {
      T.push(e + '[T\\s]' + a);
    }));
  }));
  var N = T.map((function(e) {
    return new RegExp('^' + e + '$');
  }));
  var A = [/^(19|20)\d{2}$/, /^\d{4}(0?[1-9]|1[012])$/, /^\d{4}(0?[1-9]|1[012])(0?[1-9]|[12]\d|3[01])$/];

  function L(e, a) {
    if (e) throw new Error(a);
  }

  function G(e) {
    return null == e || '' === e || Number.isNaN(e) || 'null' === e;
  }

  function B(e) {
    return 'number' == typeof e ? Number.isInteger(e) : !('string' != typeof e || !j(e)) && !e.includes('.');
  }

  function I(e) {
    return 'number' == typeof e ? !Number.isNaN(e) && !Number.isInteger(e) : !('string' != typeof e || !j(e)) && e.includes('.');
  }

  function z(e) {
    return !(!e || Object.getPrototypeOf(e) !== Date.prototype) || 'string' == typeof e && function(e) {
      var a, t;
      try {
        for (var n = s(N), r = n.next(); !r.done; r = n.next()) {
          if (r.value.test(e.trim())) return !0;
        }
      } catch (e) {
        a = { error: e };
      } finally {
        try {
          r && !r.done && (t = n.return) && t.call(n);
        } finally {
          if (a) throw a.error;
        }
      }
      return !1;
    }(e);
  }

  function j(e) {
    var a, t, n = !1;
    /^[+-]/.test(e) && (e = e.slice(1));
    try {
      for (var r = s(e), i = r.next(); !i.done; i = r.next()) {
        var o = i.value;
        if ('.' === o) {
          if (!1 === n) {
            n = !0;
            continue;
          }
          return !1;
        }
        if (!/[0-9]/.test(o)) return !1;
      }
    } catch (e) {
      a = { error: e };
    } finally {
      try {
        i && !i.done && (t = r.return) && t.call(r);
      } finally {
        if (a) throw a.error;
      }
    }
    return '' !== e.trim();
  }

  var F = new WeakMap;

  function H(e, a, t) {
    return F.get(e) || F.set(e, new Map), F.get(e).set(a, t), t;
  }

  function E(e, a) {
    var t = F.get(e);
    if (t) return t.get(a);
  }

  function W(e) {
    var a = E(e, 'min');
    return void 0 !== a ? a : H(e, 'min', Math.min.apply(Math, d(e)));
  }

  function q(e) {
    var a = E(e, 'max');
    return void 0 !== a ? a : H(e, 'max', Math.max.apply(Math, d(e)));
  }

  function U(e) {
    var a = E(e, 'minIndex');
    return void 0 !== a ? a : H(e, 'minIndex', function(e) {
      var a = e[0], t = 0;
      for (var n in e) e[n] < a && (t = Number(n), a = e[n]);
      return t;
    }(e));
  }

  function $(e) {
    var a = E(e, 'maxIndex');
    return void 0 !== a ? a : H(e, 'maxIndex', function(e) {
      var a = e[0], t = 0;
      for (var n in e) e[n] > a && (t = Number(n), a = e[n]);
      return t;
    }(e));
  }

  function J(e) {
    var a = E(e, 'sum');
    return void 0 !== a ? a : H(e, 'sum', e.reduce((function(e, a) {
      return a + e;
    }), 0));
  }

  function Y(e) {
    var a = {};
    return e.forEach((function(e) {
      a[e] ? a[e] += 1 : a[e] = 1;
    })), a;
  }

  function Z(e) {
    return e.sort((function(e, a) {
      return e > a ? 1 : -1;
    }));
  }

  function K(e, a, t) {
    return void 0 === t && (t = !1), L(a <= 0 || a >= 100, 'percent cannot be between (0, 100)'), (t ? e : Z(e))[Math.ceil(e.length * a / 100) - 1];
  }

  function V(e) {
    return J(e) / e.length;
  }

  function X(e) {
    var a = V(e), t = E(e, 'variance');
    return void 0 === t ? H(e, 'variance', e.reduce((function(e, t) {
      return e + Math.pow(t - a, 2);
    }), 0) / e.length) : t;
  }

  function ee(e) {
    return Math.sqrt(X(e));
  }

  function ae(e, a) {
    return function(e, a) {
      return L(e.length !== a.length, 'x and y must has same length'), V(e.map((function(e, t) {
        return e * a[t];
      }))) - V(e) * V(a);
    }(e, a) / (Math.sqrt(V(e.map((function(e) {
      return e * e;
    }))) - Math.pow(V(e), 2)) * Math.sqrt(V(a.map((function(e) {
      return e * e;
    }))) - Math.pow(V(a), 2)));
  }

  function te(e) {
    return G(e) ? 'null' : 'number' == typeof e ? Number.isInteger(e) ? 'integer' : 'float' : 'string' == typeof e && j(e) ? e.includes('.') ? 'float' : 'integer' : z(e) ? 'date' : 'string';
  }

  function ne(e) {
    var a, t = e.map((function(e) {
      return G(e) ? null : e;
    })), n = Y(t), r = n.null ? t.filter((function(e) {
      return null !== e;
    })) : t, i = t.map((function(e) {
      return te(e);
    })), o = Object.keys(Y(i)).filter((function(e) {
      return 'null' !== e;
    }));
    switch (o.length) {
      case 0:
        a = 'null';
        break;
      case 1:
        if ('integer' === (a = o[0])) for (var c = t.filter((function(e) {
          return null !== e;
        })), s = function(e) {
          var t = A[e];
          if (!c.some((function(e) {
            return !t.test(e);
          }))) return a = 'date', 'break';
        }, l = 0; l < A.length; l++) {
          if ('break' === s(l)) break;
        }
        break;
      case 2:
        a = o.includes('integer') && o.includes('float') ? 'float' : 'string';
        break;
      default:
        a = 'string';
    }
    var d, m = function(e) {
      return Array.from(new Set(e));
    }(r), h = {
      count: e.length,
      distinct: m.length,
      type: o.length <= 1 ? o[0] || 'null' : 'mixed',
      recommendation: a,
      missing: n.null || 0,
      samples: e,
      valueMap: n,
    };
    if (o.length > 1) {
      var u = {};
      o.forEach((function(e) {
        'date' === e ? u.date = ne(r.filter(z)) : 'integer' === e ? u.integer = ne(r.filter(B)) : 'float' === e ? u.float = ne(r.filter(I)) : 'string' === e && (u.string = ne(r.filter((function(e) {
          return 'string' === te(e);
        }))));
      })), h.meta = u;
    }
    return 2 === h.distinct && 'date' !== h.recommendation && (t.length >= 100 ? h.recommendation = 'boolean' : (d = m, [[!0, !1], [0, 1], ['true', 'false'], ['Yes', 'No'], ['True', 'False'], ['0', '1'], ['是', '否']].some((function(e) {
      return d.every((function(a) {
        return e.includes(a);
      }));
    })) && (h.recommendation = 'boolean'))), 'string' === a && Object.assign(h, function(e) {
      var a = e.map((function(e) {
        return e.length;
      }));
      return {
        maxLength: q(a), minLength: W(a), meanLength: V(a), containsChars: e.some((function(e) {
          return /[A-z]/.test(e);
        })), containsDigits: e.some((function(e) {
          return /[0-9]/.test(e);
        })), containsSpace: e.some((function(e) {
          return /\s/.test(e);
        })), containsNonWorlds: !1,
      };
    }(r.map((function(e) {
      return '' + e;
    })))), 'integer' !== a && 'float' !== a || Object.assign(h, function(e) {
      return {
        minimum: W(e),
        maximum: q(e),
        mean: V(e),
        percentile5: K(e, 5),
        percentile25: K(e, 25),
        percentile50: K(e, 50),
        percentile75: K(e, 75),
        percentile95: K(e, 95),
        sum: J(e),
        variance: X(e),
        stdev: ee(e),
        zeros: e.filter((function(e) {
          return 0 === e;
        })).length,
      };
    }(r.map((function(e) {
      return 1 * e;
    })))), 'date' === a && Object.assign(h, function(e, a) {
      void 0 === a && (a = !1);
      var t = e.map((function(e) {
        if (a) {
          var t = '' + e;
          if (8 === t.length) return new Date(t.substr(0, 4) + '/' + t.substr(4, 2) + '/' + t.substr(6, 2)).getTime();
        }
        return new Date(e).getTime();
      }));
      return { minimum: e[U(t)], maximum: e[$(t)] };
    }(r, 'integer' === h.type)), h;
  }

  function re(e) {
    var a = e.samples;
    if ('string' !== e.recommendation) return !1;
    if (function(e) {
      return 1 === e.distinct;
    }(e)) return !1;
    for (var t = a.filter((function(e) {
      return !G(e);
    })), n = null, r = null, i = -1, o = -1; ;) {
      for (var c = !0, s = 0; s < t.length; s++) {
        var l = (d = t[s])[i + 1];
        if (null !== n && 0 !== s || (n = l), l !== n) {
          c = !1;
          break;
        }
      }
      if (!c) break;
      i += 1;
    }
    for (; ;) {
      for (c = !0, s = 0; s < t.length; s++) {
        var d;
        l = (d = t[s])[d.length - 1 - (o + 1)];
        if (null !== r && 0 !== s || (r = l), l !== r) {
          c = !1;
          break;
        }
      }
      if (!c) break;
      o += 1;
    }
    var m = [/\d+/, /(零|一|二|三|四|五|六|七|八|九|十)+/, /(一|二|三|四|五|六|日)/, /^[a-z]$/, /^[A-Z]$/];
    if (-1 === i && -1 === o) return !1;
    var h = t.map((function(e) {
      return e.slice(-1 === i ? 0 : i + 1, -1 === o ? void 0 : e.length - o - 1);
    })), u = function(e) {
      var a = m[e];
      if (!h.some((function(e) {
        return !a.test(e);
      }))) return { value: !0 };
    };
    for (s = 0; s < m.length; s++) {
      var p = u(s);
      if ('object' == typeof p) return p.value;
    }
    return !1;
  }

  function ie(e, a) {
    var t = ['integer', 'float'];
    L(!(t.includes(e.recommendation) && t.includes(a.recommendation)), 'field\'s type must be integer or float');
    var n = l(function(e, a) {
      for (var t = [], n = [], r = 0; r < e.length; r++) G(e[r]) || G(a[r]) || (t.push(e[r]), n.push(a[r]));
      return [t, n];
    }(e.samples, a.samples), 2), r = n[0], i = n[1];
    return ae(r.map(Number.parseFloat), i.map(Number.parseFloat));
  }

  var oe = '__AUTO_CHART__',
    ce = '\n  .'.concat(oe, 'toolbar {\n    position: absolute;\n    bottom: 0px;\n    left: 0px;\n    z-index: 10;\n    display: none;\n    box-sizing: border-box;\n  }\n  .').concat(oe, 'toolbar * {\n    box-sizing: border-box;\n  }\n  .').concat(oe, 'advice_container {\n    width: 290px;\n    display: none;\n    padding: 0 16px;\n    background: #454857;\n    position: absolute;\n    bottom: 100%;\n    left: 0;\n    max-height: 195px;\n    overflow: auto;\n  }\n  .').concat(oe, 'advice {\n    height: 65px;\n    font-size: 12px;\n    color: #FFFFFF;\n    display: flex;\n    padding: 9px 0;\n    cursor: pointer;\n    border-bottom: 1px solid #D8D8D8;\n  }\n  .').concat(oe, 'advice img {\n    height: 46px;\n    width: 46px;\n    background: #fff;\n  }\n  .').concat(oe, 'advice * {\n    pointer-events: none;\n    line-height: 46px;\n    font-size: 14px;\n  }\n  .').concat(oe, 'advice>div:nth-child(1) {\n    width: 46px;\n  }\n  .').concat(oe, 'advice>div:nth-child(2) {\n    width: 46px;\n  }\n  .').concat(oe, 'advice>div:nth-child(3) {\n    margin-left: 8px;\n    flex-grow: 1;\n  }\n  .').concat(oe, 'advice>div:nth-child(3) div {\n    line-height: 23px;\n    text-align: right;\n  }\n  .').concat(oe, 'advice:last-child{\n    border: none;\n  }\n  .').concat(oe, 'chart_type_btn {\n    height: 24px;\n    width: 24px;\n    text-align: center;\n    display: inline-block;\n    padding: 6px;\n    background: #454857;\n    color: #fff;\n    cursor: pointer;\n  }\n  .').concat(oe, 'chart_type_btn img {\n    pointer-events: none;\n    height: 12px;\n    width: 12px;\n    vertical-align: top;\n  }\n  .').concat(oe, 'dev_btn {\n    height: 27px;\n    line-height: 27px;\n    background: #454857;\n    padding: 0 7px;\n    color: #fff;\n    display: none;\n    position: absolute;\n    bottom: 0;\n    right: 0;\n    user-select: none;\n    cursor: pointer;\n  }\n  .').concat(oe, 'dev_panel {\n    border-radius: 5px;\n    overflow: hidden;\n    box-shadow: 10px 10px 20px rgba(0, 0, 0, 0.25);\n    box-sizing: border-box;\n    position: absolute;\n    background: #fff;\n    z-index: 1000;\n    display: none;\n  }\n  .').concat(oe, 'dev_panel header {\n    box-sizing: border-box;\n    height: ').concat(32, 'px;\n    width: 100%;\n    padding-left: 16px;\n    line-height: ').concat(32, 'px;\n    cursor: move; \n    color: #fff;\n    position: relative;\n    z-index: 1;\n    background-color: #454857;\n    box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.45);\n  }\n  .').concat(oe, 'dev_panel_close {\n    margin: 8px;\n    height: 16px;\n    width: 16px;\n    border-radius: 50%;\n    background: #fff;\n    text-align: center;\n    color: #454857;\n    font-size: 14px;\n    line-height: 14px;\n    cursor: pointer;\n    float: right;\n  }\n  .').concat(oe, 'dev_panel_content {\n    width: 100%;\n    height: calc(100% - ').concat(32, 'px);\n  }\n  .').concat(oe, 'dev_panel_content iframe {\n    height: 100%;\n    width: 100%;\n    border: none;\n  }\n  .').concat(oe, 'dev_panel_mask {\n    position: absolute;\n    top: 0;\n    right: 0;\n    bottom: 0;\n    left: 0;\n    z-index: -1;\n  }\n  .').concat(oe, 'no_data_content, .').concat(oe, 'mock_guide {\n    color: #aaa;\n    text-align: center;\n    position: relative;\n    top: 50%;\n    transform: translateY(-50%);\n  }\n  .').concat(oe, 'mock_guide_button {\n    margin-top: 22px;\n    border-radius: 3px;\n    height: 30px;\n    width: 116px;\n    font-size: 14px;\n    display: inline-block;\n    line-height: 30px;\n    background: #454859;\n    color: #fff;\n    cursor: pointer;\n  }\n  \n'),
    se = document.createElement('style');

  function le(e) {
    return {
      line_chart: 'Line',
      step_line_chart: 'StepLine',
      area_chart: 'Area',
      stacked_area_chart: 'StackArea',
      percent_stacked_area_chart: 'PercentageStackArea',
      column_chart: 'Column',
      grouped_column_chart: 'GroupColumn',
      stacked_column_chart: 'StackColumn',
      percent_stacked_column_chart: 'PercentageStackColumn',
      bar_chart: 'Bar',
      grouped_bar_chart: 'GroupBar',
      stacked_bar_chart: 'StackBar',
      percent_stacked_bar_chart: 'PercentageStackBar',
      histogram: 'Histogram',
      pie_chart: 'Pie',
      donut_chart: 'Ring',
      rose_chart: 'Rose',
      scatter_plot: 'Scatter',
      bubble_chart: 'Bubble',
      radar_chart: 'Radar',
      heatmap: 'Matrix',
    }[e] || e;
  }

  se.textContent = ce, document.head.prepend(se);

  function de(e) {
    return function(e) {
      if (Array.isArray(e)) return he(e);
    }(e) || function(e) {
      if ('undefined' != typeof Symbol && Symbol.iterator in Object(e)) return Array.from(e);
    }(e) || me(e) || function() {
      throw new TypeError('Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.');
    }();
  }

  function me(e, a) {
    if (e) {
      if ('string' == typeof e) return he(e, a);
      var t = Object.prototype.toString.call(e).slice(8, -1);
      return 'Object' === t && e.constructor && (t = e.constructor.name), 'Map' === t || 'Set' === t ? Array.from(e) : 'Arguments' === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? he(e, a) : void 0;
    }
  }

  function he(e, a) {
    (null == a || a > e.length) && (a = e.length);
    for (var t = 0, n = new Array(a); t < a; t++) n[t] = e[t];
    return n;
  }

  function ue(e, a) {
    var t = Object.keys(e);
    if (Object.getOwnPropertySymbols) {
      var n = Object.getOwnPropertySymbols(e);
      a && (n = n.filter((function(a) {
        return Object.getOwnPropertyDescriptor(e, a).enumerable;
      }))), t.push.apply(t, n);
    }
    return t;
  }

  function pe(e) {
    for (var a = 1; a < arguments.length; a++) {
      var t = null != arguments[a] ? arguments[a] : {};
      a % 2 ? ue(Object(t), !0).forEach((function(a) {
        fe(e, a, t[a]);
      })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ue(Object(t)).forEach((function(a) {
        Object.defineProperty(e, a, Object.getOwnPropertyDescriptor(t, a));
      }));
    }
    return e;
  }

  function fe(e, a, t) {
    return a in e ? Object.defineProperty(e, a, {
      value: t,
      enumerable: !0,
      configurable: !0,
      writable: !0,
    }) : e[a] = t, e;
  }

  var ye = o('en-US', !0);

  function ge(e, a) {
    return e.distinct < a.distinct ? 1 : e.distinct > a.distinct ? -1 : 0;
  }

  function _e(e, a) {
    return a.every((function(a) {
      return e.includes(a);
    }));
  }

  function ve(e, a) {
    return a.some((function(a) {
      return e.includes(a);
    }));
  }

  function be(e) {
    var a = function(e, a) {
      if (L(a && 0 === a.length, 'fields.length woudle greater than 0'), !a) {
        var t = new Set;
        e.forEach((function(e) {
          return Object.keys(e).forEach((function(e) {
            return t.add(e);
          }));
        })), a = d(t);
      }
      return a.map((function(a) {
        return c(c({}, ne(e.map((function(e) {
          return e[a];
        })))), { name: a });
      }));
    }(e), t = [];
    return a.forEach((function(e) {
      var a = [];
      (function(e) {
        return 'boolean' === e.recommendation || 'string' === e.recommendation && !re(e);
      })(e) && a.push('Nominal'), re(e) && a.push('Ordinal'), function(e) {
        return 'integer' === e.recommendation || 'float' === e.recommendation;
      }(e) && a.push('Interval'), function(e) {
        return 'integer' === e.recommendation;
      }(e) && a.push('Discrete'), function(e) {
        return 'float' === e.recommendation;
      }(e) && a.push('Continuous'), function(e) {
        return 'date' === e.recommendation;
      }(e) && a.push('Time');
      var n = pe(pe({}, e), {}, { levelOfMeasurements: a });
      t.push(n);
    })), t;
  }

  function Ce(e, a) {
    var t = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], n = a ? a.purpose : '',
      r = a ? a.preferences : void 0, i = Object.keys(ye), o = i.map((function(a) {
        var i = 0, o = {}, c = 1;
        x.filter((function(e) {
          return 'HARD' === e.hardOrSoft && e.specChartTypes.includes(a);
        })).forEach((function(t) {
          var i = t.check({ dataProps: e, chartType: a, purpose: n, preferences: r });
          c *= i, o[t.id] = i;
        }));
        var s = 0;
        x.filter((function(e) {
          return 'SOFT' === e.hardOrSoft && e.specChartTypes.includes(a);
        })).forEach((function(t) {
          var i = t.check({ dataProps: e, chartType: a, purpose: n, preferences: r });
          s += i, o[t.id] = i;
        })), i = c * (1 + s), t && console.log('💯score: ', i, '=', c, '* (1 +', s, ') ;charttype: ', a), t && console.log(o);
        var l = {};
        if ('pie_chart' === a || 'donut_chart' === a) {
          var d = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })), m = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          m && d ? (l.color = d.name, l.angle = m.name) : i = 0;
        }
        if ('line_chart' === a || 'step_line_chart' == a) {
          var h = e.find((function(e) {
            return ve(e.levelOfMeasurements, ['Time', 'Ordinal']);
          })), u = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          })), p = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          }));
          p && (l.color = p.name), h && u ? (l.x = h.name, l.y = u.name) : i = 0;
        }
        if ('area_chart' === a) {
          var f = e.find((function(e) {
            return ve(e.levelOfMeasurements, ['Time', 'Ordinal']);
          })), y = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          })), g = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          }));
          g && (l.color = g.name), f && y ? (l.x = f.name, l.y = y.name) : i = 0;
        }
        if ('bar_chart' === a) {
          var _ = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })).sort(ge), v = _[0], b = _[1], C = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          C && v ? (l.y = v.name, l.x = C.name, b && (l.color = b.name)) : i = 0;
        }
        if ('column_chart' === a) {
          var R = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })).sort(ge), P = R[0], S = R[1], k = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          P && k ? (l.y = k.name, l.x = P.name, S && (l.color = S.name)) : i = 0;
        }
        if ('grouped_bar_chart' === a || 'stacked_bar_chart' === a || 'percent_stacked_bar_chart' === a) {
          var w = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })).sort(ge), O = w[0], Q = w[1], D = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          O && Q && D ? (l.y = O.name, l.y2 = Q.name, l.x = D.name) : i = 0;
        }
        if ('grouped_column_chart' === a || 'stacked_column_chart' === a || 'percent_stacked_column_chart' === a) {
          var M = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })).sort(ge), T = M[0], N = M[1], A = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          T && N && A ? (l.x = T.name, l.x2 = N.name, l.y = A.name) : i = 0;
        }
        if ('stacked_area_chart' === a || 'percent_stacked_area_chart' === a) {
          var L = e.find((function(e) {
            return ve(e.levelOfMeasurements, ['Time', 'Ordinal']);
          })), G = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })), B = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          L && G && B ? (l.x = L.name, l.x2 = G.name, l.y = B.name) : i = 0;
        }
        if ('radar_chart' === a || 'treemap' === a || 'mechanical_bubble_chart' === a) {
          var I = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })).sort(ge), z = I[0], j = I[1], F = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          z && F ? (l.x = z.name, l.size = F.name, j && (l.x2 = j.name)) : i = 0;
        }
        if ('wordcloud' === a || 'funnel_chart' === a) {
          var H = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          })), E = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          H && E ? (l.series = H.name, l.size = E.name) : i = 0;
        }
        if ('scatter_plot' === a) {
          var W = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          })).sort(ge), q = W[0], U = W[1], $ = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Nominal']);
          }));
          q && U ? (l.x = q.name, l.y = U.name, $ && (l.color = $.name)) : i = 0;
        }
        if ('bubble_chart' === a) {
          for (var J = e.filter((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          })), Y = { x: J[0], y: J[1], corr: 0, size: J[2] }, Z = function(e) {
            for (var a = function(a) {
              var t = ie(J[e], J[a]);
              Math.abs(t) > Y.corr && (Y.x = J[e], Y.y = J[a], Y.corr = t, Y.size = J[de(Array(J.length).keys()).find((function(t) {
                return t !== e && t !== a;
              })) || 0]);
            }, t = e + 1; t < J.length; t++) a(t);
          }, K = 0; K < J.length; K++) Z(K);
          var V = Y.x, X = Y.y, ee = Y.size, ae = e.find((function(e) {
            return ve(e.levelOfMeasurements, ['Nominal']);
          }));
          V && X && ee ? (l.x = V.name, l.y = X.name, l.size = ee.name, ae && (l.color = ae.name)) : i = 0;
        }
        if ('histogram' === a) {
          var te = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          te ? l.x = te.name : i = 0;
        }
        if ('heatmap' === a) {
          var ne = e.filter((function(e) {
            return ve(e.levelOfMeasurements, ['Nominal', 'Ordinal']);
          })).sort(ge), re = ne[0], oe = ne[1], ce = e.find((function(e) {
            return _e(e.levelOfMeasurements, ['Interval']);
          }));
          re && oe && ce ? (l.x = re.name, l.y = oe.name, l.color = ce.name) : i = 0;
        }
        return { type: a, channels: l, score: i };
      }));

    function c(e, a) {
      return e.score < a.score ? 1 : e.score > a.score ? -1 : 0;
    }

    var s = o.filter((function(e) {
      return e.score && 0 !== e.score && le(e.type);
    })).sort(c);
    return t && console.log('🍒🍒🍒🍒🍒🍒 resultList 🍒🍒🍒🍒🍒🍒'), t && console.log(s), s;
  }

  function xe(e, a) {
    var t = arguments.length > 2 && void 0 !== arguments[2] && arguments[2];
    t && console.log('💠💠💠💠💠💠 data 💠💠💠💠💠💠'), t && console.log(e), t && console.log('🍯🍯🍯🍯🍯🍯 options 🍯🍯🍯🍯🍯🍯'), t && console.log(a);
    var n = be(e);
    t && console.log('🔶🔶🔶🔶🔶🔶 dataset analysis 🔶🔶🔶🔶🔶🔶'), t && console.log(n);
    var r = Ce(n, a, !0);
    return r;
  }
}]);
//# sourceMappingURL=index.js.map