
window.env.node = true;

function _toImage(canvas, options, width, height) {

    options.moreLabel = {enabled: false};

    options.plotOptions.large = false; //现在都是canvas

    var axis = []
        .concat(options.xAxis || [])
        .concat(options.yAxis || [])
        .concat(options.angleAxis || [])
        .concat(options.radiusAxis || []);

    for(var i = 0, len = axis.length; i < len; i++) {

        var aex = axis[i];

        if(aex.useHtml) {
            aex.labelRotation = 0;
        }

        if(aex.title && aex.title.useHtml) {
            aex.title.rotation = 0;
        }

    }

    window.VanCharts.initPaddingScale(options.scale || 1);

    canvas.width = width;
    canvas.height = height;

    var vanCharts = window.VanCharts.init(canvas);

    vanCharts.setOptions(options);

    var chart = vanCharts.charts[0];

    var renderer = chart.emptyDataRender ? chart.emptyDataRender.renderer : chart.renderer;

    renderer._zr.refreshImmediately();

}

function toImage(canvas, options, width, height) {

    options = JSON.parse(options);

    if(options && options.options) {
        options = options.options[0];
    }

    options.zoom && options.zoom.zoomTool && (options.zoom.zoomTool.enabled = false);
    options.tools && (options.tools.enabled = false);
    options.timeAxis && (options.timeAxis.zoom = false);

    _toImage(canvas, options, width, height);

}

function toDesignImage(canvas, options, width, height) {

    options = JSON.parse(options);

    if(options && options.options) {
        options = options.options[0];
    }

    _toImage(canvas, options, width, height);

}