function VanChartWidget(options, dom) {

    if (options.requiredJS) {
        for (var i = 0; i < options.requiredJS.length; i++) {
            FR.$defaultImport(options.requiredJS[i], 'js');
        }
    }

    if (options.requiredCSS) {
        for (var i = 0; i < options.requiredCSS.length; i++) {
            FR.$defaultImport(options.requiredCSS[i], 'css');
        }
    }

    this.options = options;

    if (window[options.wrapperName]) {
        this.chartWrapper = new window[options.wrapperName](options, dom);
    } else if (Van.FRChartBridge[options.wrapperName]) {
        this.chartWrapper = new Van.FRChartBridge[options.wrapperName](options, dom);
    }

}

VanChartWidget.prototype.resize = function (width, height) {

    this.chartWrapper && this.chartWrapper.resize();

};

VanChartWidget.prototype.refresh = function (options) {

};

VanChartWidget.prototype.changeParameter = function (para) {
    this.chartWrapper && this.chartWrapper.dealChartAjax(para);
};

VanChartWidget.prototype.remove = function () {
    this.chartWrapper && this.chartWrapper.clearAll();

    this.options = this.chartWrapper = null;
};



