/*
 * 图表 初始化属性
 * @kunsnat@gmail.com
 * Copyright (c) 2001-2014,FineReport Inc, All Rights Reserved.
 */


// ChartData {一般类型的数据  2纬} -->

//  处理同步相关的颜色边框根据PlotType --> 转化到每个DataSeries DataPoint中.
//   同步 Plot的系列属性设置.
//
// (不一定需要全部, 只要暂时提供一个类似接口, 以后可以慢慢加入)

// myChart.setOption(option, true);  通过此方法 将option的属性设置到对应的每个层级关系中

// http://echarts.baidu.com/doc/doc.html#选项

// 除了计算得到的之外,  plotGlyph中的 'seriesList'   DataSeries  DataPoint     LegendGlyph  item[];
//
// 其余的直接传入,  合并属性.  得到结果.



var option = {
    category : ['a', 'b', 'c'],  // datatype  --- plotType  数据类型
    series : ['1', '2', '3'],
    data : [ // 数据分组 --> 根据不同的Type, 需要定义不同的数据格式.  普通的NormalChartData --->
        ['11','12','13'],
        ['21','22','23'],
        ['31','32','33']
    ],

    legend: { // ---> 全部由数据 默认生成.
        position:'right',
        items : ['1', '2', '3']
    },

    plotAttr :  {
        seriesOverlapPercent : 10,
        categoryIntervalPercent : 10
    },

    // 绘图区  坐标轴 警戒线
    plotArea : {
        backgroundColor : 'red', // 背景颜色
        borderColor : 'blue',  // 边框颜色
        boderLine : '1', // 边框线型


        xAxis: {// 最大值  最小值 未知  也需要 事先从 data中计算.
            position : 'bottom'

        },

        yAxis: {
            position : 'left'
        },

        secondAxis : {
            position :'right'
        }

    },


    // 交互属性
    hotTip : '', // 数据点提示.  value cate series 等.
    animation: false, // 动态展示
    axisTip : false, // 坐标轴提示
    preChart : false // 缩放
};
var ecConfig = require('echarts/config');
myChart.on(ecConfig.EVENT.MAP_SELECTED, function(param){// 加载 事件方法..   事件中心的集中处理. (MessageCenter  on)
    var selected = param.selected;
    var mapSeries = option.series[0];
    var data = [];
    var legendData = [];
    var name;
    for (var p = 0, len = mapSeries.data.length; p < len; p++) {
        name = mapSeries.data[p].name;
        mapSeries.data[p].selected = selected[name];
        if (selected[name]) {
            data.push({
                name: name,
                value: mapSeries.data[p].value
            });
            legendData.push(name);
        }
    }
    option.legend.data = legendData;
    option.series[1].data = data;
    myChart.setOption(option, true);
})